#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Menu_Button.H>

//
// How to reproduce the faulty behaviour:
//
// As soon as the "Test" window appears click on the menu button.
// Do not dismiss the popup menu. Instead wait until 3 second timeout
// triggers the show_window() function and the "Test 2" window appears.
// Now you can dismiss the popup menu. The second window will disappear
// along with the popup menu, which obviously was nobodies intention.
//

void show_window (void *param)
{
	Fl_Window *w = (Fl_Window*) param;
	// No matter whether I use iconize() or show() the window
	// disappears as soon as the popup menu is dismissed.
	// w -> iconize();
	w -> show();
}

main()
{
	struct Fl_Menu_Item menu[] = {
		{"One"},
		{"Two"},
		{"Three"},
		{0}
	};
	Fl_Window w (0, 0, 100, 100, "Test");
	Fl_Menu_Button b (0, 0, 100, 25, "Menu");
	b.menu (menu);
	w.end();
	Fl_Window w2 (100, 100, 100, 100, "Test 2");
	w2.end();
	Fl::add_timeout (3, show_window, &w2);
	w.show();
	return Fl::run();
}
